﻿Imports System.Net
Imports System.ComponentModel


Public Class FTPUpDownMain

    Public credientials As NetworkCredential
    Private PvS_FileName As String = ""
    Private PvCS_FoldName As String

    'Declaration

    Public m_CountTo As Integer = 0 ' How many time to loop. 


    Public Sub Increment(ByVal value As Integer) 'Added for Progress bar
        ' Set the interval for the timer.
        Timer1.Interval = 250
        ' Connect the Tick event of the timer to its event handler. 
        AddHandler Timer1.Tick, AddressOf ProgressBar1_Validating
        ' Start the timer.
        Timer1.Start()

    End Sub

    Private Sub Btn_SelectFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SelectFile.Click
        Dim fd As OpenFileDialog = New OpenFileDialog()
        Dim strFileName As String
        fd.Title = "Open File Dialog"
        fd.InitialDirectory = "C:\"
        fd.Filter = "All files (*.*)|*.*|All files (*.*)|*.*"
        fd.FilterIndex = 2
        fd.RestoreDirectory = True
        If fd.ShowDialog() = DialogResult.OK Then
            strFileName = fd.FileName
            TxtPath.Text = strFileName
            PvS_FileName = fd.SafeFileName
        End If
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click


        If (TxtPath.Text.Length = 0 Or PvS_FileName.Length = 0) Then
            MessageBox.Show("Please Select the File to Upload")
            Return
        End If
        If Not IO.File.Exists(TxtPath.Text) Then
            MessageBox.Show("Selected file doesn't exists")
            Return
        End If


        Dim clsRequest As System.Net.FtpWebRequest = _
        DirectCast(System.Net.WebRequest.Create(TxtUFTPPath.Text & PvS_FileName), System.Net.FtpWebRequest)

        clsRequest.Credentials = New System.Net.NetworkCredential("", "")
        clsRequest.Method = System.Net.WebRequestMethods.Ftp.UploadFile
        ''rfshTMR.Enabled = True
        Dim File() As Byte = System.IO.File.ReadAllBytes(TxtPath.Text)
        Dim clsStream As System.IO.Stream = _
            clsRequest.GetRequestStream()
        clsStream.Write(File, 0, File.Length)
        For offset As Integer = 0 To File.Length Step 1024
            ProgressBar1.Value = CType(offset * ProgressBar1.Maximum / File.Length, Integer)
            Dim chunkSize As Double = File.Length - offset - 1
            'Dim chunkSize As Double = File.Length - offset - 1
            If chunkSize > 1024 Then chunkSize = 1024
            clsStream.Write(File, offset, chunkSize)
            ProgressBar1.Value = ProgressBar1.Maximum
        Next
        clsStream.Close()
        clsStream.Dispose()
        MsgBox("File uploaded to FTP", MsgBoxStyle.OkOnly, "Upload Complete")

        'for web brow
        WebBrowser1.Refresh()
    End Sub

    Private Sub Btn_Dir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Dir.Click
        'If TxtDownFileName.Text = " " Then
        '    MsgBox("Please enter the File name to be downloaded")
        'End If

        If TxtDownloadPath.Text = " " Then
            MsgBox("Please select the Directory ")
        End If

        Dim folderDlg As New FolderBrowserDialog
        folderDlg.ShowNewFolderButton = True
        If (folderDlg.ShowDialog() = DialogResult.OK) Then
            TxtDownloadPath.Text = folderDlg.SelectedPath
            PvCS_FoldName = TxtDownloadPath.Text
            Dim root As Environment.SpecialFolder = folderDlg.RootFolder
        End If
    End Sub

    Private Sub Btn_Download_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Download.Click
        'Dim elementname As String
        'Dim id As String
        'Dim innertext As String
        'Dim outertext As String
        'Dim innerhtml As String
        'Dim outerhtml As String
        WebBrowser1.Document.ActiveElement.InnerText = "hello"
        MsgBox(WebBrowser1.Document.All.GetElementsByName("q").Item(0).GetAttribute("value").ToString)
        'Dim strfilename As String = WebBrowser1.Document.Window



        Dim elements As Integer = WebBrowser1.Document.All.Count

        Dim x = WebBrowser1.Document.ActiveElement
        If x IsNot Nothing Then

            Dim fileUrl As String = x.GetAttribute("href")
        End If




        Dim Temp1, Temp2
        Dim i = 0
        Temp1 = WebBrowser1.Document.All.Item(i).Name
        Temp2 = WebBrowser1.DocumentText.ToString.ToLower()

        'If TxtDownFileName.Text = " " Then
        '    MsgBox("Please enter the File name to be downloaded")
        'End If

        'If TxtDownloadPath.Text = " " Then
        '    MsgBox("Please select the Directory ")
        'End If


        'Values to use
        'Dim localFile As String = PvCS_FoldName + "\" + TxtDownFileName.Text
        'Dim remoteFile As String = "/" + TxtDownFileName.Text
        'Dim host As String = TxtFTPSite.Text
        Const username As String = ""
        Const password As String = ""

        '  If (TxtDownFileName.Text.Length = 0 Or TxtDownloadPath.Text.Length = 0) Then
        '    MessageBox.Show("Download File name and Download Path Must be given")
        '    Return
        'End If
        'If Not IO.Directory.Exists(TxtDownloadPath.Text) Then
        '    MessageBox.Show("Selected Download path doesn't exists")
        '    Return
        'End If
        '1. Create a request: must be in ftp://hostname format, 
        '   not just ftp.myhost.com
        ' Dim URI As String = host & remoteFile
        'Dim ftp As System.Net.FtpWebRequest = _
        '    CType(FtpWebRequest.Create(URI), FtpWebRequest)

        '2. Set credentials
        'ftp.Credentials = New  _
        '    System.Net.NetworkCredential(username, password)

        ''''''''added now for progress bar
        'Dim a As String
        'a = TxtFTPSite.Text + TxtDownFileName.Text
        'For offset As Integer = 0 To FileLen(a) Step 1024
        '    ProgressBar2.Value = CType(offset * ProgressBar2.Maximum / FileLen(a), Integer)
        '    Dim chunkSize As Integer = FileLen(a) - offset - 1
        '    If chunkSize > 1024 Then chunkSize = 1024
        '    '  strz.Write(PvS_FileName, offset, chunkSize)
        '    ProgressBar2.Value = ProgressBar2.Maximum
        'Next

        '////////////////////////////////
        'Dim clsRequest As System.Net.FtpWebRequest = _
        'DirectCast(System.Net.WebRequest.Create(TxtFTPSite.Text + TxtDownFileName.Text), System.Net.FtpWebRequest)  'this line is commented by Seema

        Dim _Html As String
        _Html = WebBrowser1.Document.Body.InnerHtml

        ' Dim clsRequest As System.Net.FtpWebRequest = _
        'DirectCast(System.Net.WebRequest.Create(TxtFTPSite.Text + TxtDownFileName.Text), System.Net.FtpWebRequest)  'this line is commented by Seema
      
        ' clsRequest.Credentials = New System.Net.NetworkCredential("", "")
        'clsRequest.Method = System.Net.WebRequestMethods.Ftp.UploadFile
        ''rfshTMR.Enabled = True
        Dim File() As Byte = System.IO.File.ReadAllBytes(TxtPath.Text)
        ' Dim clsStream As System.IO.Stream = _
        'clsRequest.GetRequestStream()
        'clsStream.Write(File, 0, File.Length)
        'For offset As Integer = 0 To File.Length Step 1024
        '    ProgressBar2.Value = CType(offset * ProgressBar2.Maximum / File.Length, Integer)
        '    Dim chunkSize As Long = File.Length - offset - 1
        '    'Dim chunkSize As Double = File.Length - offset - 1
        '    If chunkSize > 1024 Then chunkSize = 1024
        '    clsStream.Write(File, offset, chunkSize)
        '    ProgressBar2.Value = ProgressBar2.Maximum
        'Next
        'clsStream.Close()
        'clsStream.Dispose()



        '3. Settings and action
        'ftp.KeepAlive = False
        ''we want a binary transfer, not textual data
        'ftp.UseBinary = True

        ''Define the action required (in this case, download a file)
        'ftp.Method = System.Net.WebRequestMethods.Ftp.DownloadFile




        MessageBox.Show("Selected File Downloaded Succefully from FTP Site")

        WebBrowser2.Url = New Uri(TxtDownloadPath.Text)

    End Sub


    Private Sub FTPUpDownMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '   WebBrowser1.DoDragDrop()
        GroupBox1.Enabled = False
        GroupBox2.Enabled = False

        '  WebBrowser1.ExecWB()

    End Sub



    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Me.TxtUFTPPath.Text <> "" AndAlso Me.TxtUFTPPath.Text.StartsWith("ftp://") Then

            WebBrowser1.Url = New Uri(TxtUFTPPath.Text)

            'credientials = New NetworkCredential(" ", " ", " ")

            If TxtUsername.Text = " " Or TXTpwd.Text = "" Then
                GroupBox1.Enabled = False
                GroupBox2.Enabled = False

                MessageBox.Show("Please provide the user name and password!")

            ElseIf TxtUsername.Text <> " " Or TXTpwd.Text <> "" Then
                GroupBox1.Enabled = True
                GroupBox2.Enabled = True

                credientials = New NetworkCredential(
                            TxtUsername.Text.Trim(),
                            TXTpwd.Text.Trim())

                MessageBox.Show("You are connected to FTP Server")

                '  Me.BackgroundWorker1.RunWorkerAsync()
            End If
        Else

            MessageBox.Show("Please insert valid FTP URL for download", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning)

        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        ProgressBar1.Value += 1

        If ProgressBar1.Value >= FileLen(TxtPath.Text) Then

            Timer1.Enabled = False

        End If
    End Sub


    Private Sub ProgressBar1_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ProgressBar1.Validating

        ' Increment the value of the ProgressBar a value of one each time.
        ProgressBar1.Increment(1)
        ' Determine if we have completed by comparing the value of the Value property to the Maximum value. 
        If ProgressBar1.Value = ProgressBar1.Maximum Then
            ' Stop the timer.
            Timer1.Stop()
        End If
    End Sub

    Private Sub ProgressBar1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgressBar1.Click

    End Sub
    Protected Sub ProgressChanged(ByVal sender As Object, ByVal e As ProgressChangedEventArgs)
        ProgressBar1.Value = e.ProgressPercentage
    End Sub


    Private Sub TxtUFTPPath_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtUFTPPath.TextChanged

    End Sub

    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        'Creating the request and getting the response
        Dim theResponse As HttpWebResponse
        Dim theRequest As HttpWebRequest
        Try 'Checks if the file exist

            theRequest = WebRequest.Create(Me.TxtUFTPPath.Text)
            theResponse = theRequest.GetResponse
        Catch ex As Exception

            MessageBox.Show("An error occurred while downloading file. Possibe causes:" & ControlChars.CrLf & _
                            "1) File doesn't exist" & ControlChars.CrLf & _
                            "2) Remote server error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            'Dim cancelDelegate As New DownloadCompleteSafe(AddressOf DownloadComplete)

            'Me.Invoke(cancelDelegate, True)

            Exit Sub
        End Try
        MessageBox.Show("You are connected to FTP Server")

        Dim length As Long = theResponse.ContentLength 'Size of the response (in bytes)

        ' Dim safedelegate As New ChangeTextsSafe(AddressOf ChangeTexts)
        'Me.Invoke(safedelegate, length, 0, 0, 0) 'Invoke the TreadsafeDelegate

        'Dim writeStream As New IO.FileStream(Me.whereToSave, IO.FileMode.Create)

        'Replacement for Stream.Position (webResponse stream doesn't support seek)
        Dim nRead As Integer

        'To calculate the download speed
        Dim speedtimer As New Stopwatch
        Dim currentspeed As Double = -1
        Dim readings As Integer = 0

        Do

            If BackgroundWorker1.CancellationPending Then 'If user abort download
                Exit Do
            End If

            speedtimer.Start()

            Dim readBytes(4095) As Byte
            Dim bytesread As Integer = theResponse.GetResponseStream.Read(readBytes, 0, 4096)

            nRead += bytesread
            Dim percent As Short = (nRead * 100) / length

            'Me.Invoke(safedelegate, length, nRead, percent, currentspeed)

            'If bytesread = 0 Then Exit Do

            'writeStream.Write(readBytes, 0, bytesread)

            speedtimer.Stop()

            readings += 1
            If readings >= 5 Then 'For increase precision, the speed it's calculated only every five cicles
                currentspeed = 20480 / (speedtimer.ElapsedMilliseconds / 1000)
                speedtimer.Reset()
                readings = 0
            End If
        Loop

        'Close the streams
        theResponse.GetResponseStream.Close()
        'writeStream.Close()

        'If Me.BackgroundWorker1.CancellationPending Then

        '    IO.File.Delete(Me.whereToSave)

        '    Dim cancelDelegate As New DownloadCompleteSafe(AddressOf DownloadComplete)

        '    Me.Invoke(cancelDelegate, True)

        '    Exit Sub

        'End If

        'Dim completeDelegate As New DownloadCompleteSafe(AddressOf DownloadComplete)

        '   Me.Invoke(completeDelegate, False)

    End Sub
    Private Sub WebBrowser1_DocumentCompleted(ByVal sender As System.Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) Handles WebBrowser1.DocumentCompleted

        'mshtml.HTMLDocument(doc)
        'doc = (mshtml.HTMLDocument)webBrowser1.Document
        'mshtml.HTMLDocumentEvents2_Event(iEvent)
        'iEvent = (mshtml.HTMLDocumentEvents2_Event)doc
        'iEvent.onclick += New mshtml.HTMLDocumentEvents2_onclickEventHandler(ClickEventHandler)


    End Sub
    

    Private Sub WebBrowser1_PreviewKeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles WebBrowser1.PreviewKeyDown

    End Sub
End Class
